#include <stdio.h>     // V2ljastuseks
#include <stdlib.h> // Failikontrollis exit funktsiooni jaoks
#include <malloc.h> //  Dynaamilise m2lujaotuse jaoks

 
typedef struct {
    size_t stackSize;
    size_t stackPointer;
    float *items;
} PINU;

PINU *create(size_t st);
void sisselugemine(float *A);
float pop(PINU *ps);
void v2ljastus(float *A, PINU *ps, int arv);
float kysimus();
int liikmetearv();
float rekursioon(float *A, size_t abi);
void funktsioon(float *A, PINU *ps, int arv);

int main(void){
    int arv;
    arv=liikmetearv();
    float *A;       		//  Arvude massiivi A loomine ja m2lu andmine. Saaks ka eraldi funktsiooni teha, aga yhe rea koodi v2hendamiseks main funktsioonis pole suurt m6tet
    A=(float*)malloc(sizeof(float)*arv);
    PINU *H = create(arv);  //  Pinule m2lu andmise funktsioon
    sisselugemine(A);
    funktsioon(A, H, arv);
    v2ljastus(A, H, arv);
    free(A);        		//  M2lu vabastatakse (pinu oma ja allpool arvude massiivi oma)
    free(H);
    getchar();
    return 0;
}

PINU *create(size_t st){        //  Pinule m2lu andmine eraldi funktsioonis
    PINU *ps;
    ps = (PINU*) malloc (sizeof(PINU)*2);   //  
                                            //  
    int i;
    for(i=0;i<2;i++){       //  For tsykkel m6lemale pinule m2lu andmiseks
        (ps+i) -> stackSize = st;
        (ps+i) -> stackPointer = 0;
        (ps+i) -> items = (float*)malloc(sizeof(float) * ps -> stackSize);
    }
    return ps;
}

void sisselugemine(float *A){
    FILE *sisend;
    sisend=fopen("121090IA21_F1.txt","r");
    //rewind(sisend);						//	Fail tagasi algusesse
    if(sisend==NULL){                   //  Failikontroll
        printf("Faili pole!\n");
        exit(1);
    }
    int i=0;
    while(!feof(sisend)){
        fscanf(sisend, "%f", (A+i));
        i++;
    }
    fclose(sisend);
}

float pop(PINU *ps) {
    return (ps+1)->items[(ps+1)->stackPointer];   //  V2ljastusfunktsiooni tagastatakse items kohal (ps+1)->stackPointer--
}

void v2ljastus(float *A, PINU *ps, int arv){
    FILE *v2lja;
    v2lja=fopen("121090IA21_F2.txt","w");
    if(v2lja==NULL){                   //  Failikontroll
        printf("Faili pole!\n");
        exit(1);
    }
    while((ps+0)->stackPointer != -1){      //  Siin toimub liikmete ps+0 pinust ps+1 pinusse viimine, et algset j2rjekorda saada
        (ps+1)->items[(ps+1)->stackPointer]=(ps+0)->items[(ps+0)->stackPointer];
        if((ps+1)->stackPointer<arv-1){
            (ps+1)->stackPointer++;
        }
        (ps+0)->stackPointer--;
    }
    int i=0;
    float summa=1, element;
    while((ps+1)->stackPointer != 0){      //  V2ljastus k2ib nii faili kui ka ekraanile yhtemoodi
		(ps+1)->stackPointer--;			//	Pointeri v22rtust v2hendatakse kuni 0-ni
        element=pop(ps);         //  pop funktsioon annab tulemuse returniga (funktsioon yleval n2ha)
        fprintf(v2lja, "Element H kohal %d   -   %.3f\n", i, element);
        printf("Element H kohal %d   -   %.3f\n", i, element);
        summa=*(A+i)*summa+element;
        
        i++;
    }
    printf("Summa Ai*Hi   -   %.3f\n", summa);
    fprintf(v2lja, "Summa Ai*Hi   -   %.3f\n", summa);
    fclose(v2lja);
}

float kysimus(){						//	Lisatud alamfunktsiooni "funktsioon" lihtsustamiseks
	float X;
	printf("\nSisesta reaalarv X\n");
	scanf("%f", &X);
	return X;
}

int liikmetearv(){
	int i=0;
	float abi;
	FILE *sisend;
	sisend=fopen("121090IA21_F1.txt","r");
	if(sisend==NULL){                   //  Failikontroll
        printf("Faili pole!\n");
        exit(1);
    }
    while(!feof(sisend)){
        fscanf(sisend, "%f", &abi);
        i++;
	}
	printf("\nLoeti sisse %d liiget.\n", i); 
	return i=10;
	fclose(sisend);
}

float rekursioon(float *A, size_t abi){
	int i;
	float vastus, y=1, x=1;
	for(i=0;i<abi;i++){
		y=(*(A+i))*y;
		if(i>0){
			x=i*x;
		}
	}
	vastus=y/x;
	return vastus;
}

void funktsioon(float *A, PINU *ps, int arv){
    int i;
    float X;
    X=kysimus();
    for(i=0;i<arv;i++){
		if ((ps+0)->stackPointer == 0){
            (ps+0)->items[0]=X;
		}
		if ((ps+0)->stackPointer != 0){
			(ps+0)->items[(ps+0)->stackPointer]=X*rekursioon(A, ((ps+0)->stackPointer));
			arv=arv-(ps+0)->stackPointer;					// Tehakse seni kuni rekursiooni funktsioonis jätkub A-sid, arvestatud on, et rekursioonis kulub neid aina rohkem.
															// Otsa saades pole for-loopi tingimus i<arv t2idetud
		}
		if (i<arv-1){      //  Stackpointer ei tohi minna suuremaks kui liikmeid on sisse loetud, sellep2rast n-1
            (ps+0)->stackPointer++;
        }
	}
    
}



